package diploma;

import java.lang.*;
import java.util.*;
import java.awt.*;
import gfx.*;

public class Graph extends Object{

  //datove polozky
  Node FirstNode;
  Node LastNode;
  Edge FirstEdge;
  Edge LastEdge;
  int Errors;

  //constructor
  Graph() {
    FirstNode = null;
    LastNode = null;
    FirstEdge = null;
    LastEdge = null;
    Errors = 0;
  }

    int getErrors(){
        return Errors;
    }
    void setErrors(int init_errors){
        Errors = init_errors;
    }
    
    int GetNumNodes(){
        Node n = this.FirstNode;
        int num=0;
        while(n!=null){
            num++;
            n = n.NextNode;
        }
        return num;
    }
    
    int GetNumEdges(){
        Edge e = this.FirstEdge;
        int num=0;
        while(e!=null){
            num++;
            e = e.NextEdge;
        }
        return num;
    }
    
    int GetNumLoops(){
        Edge e = this.FirstEdge;
        int num=0;
        while(e!=null){
            if(e.GetFromNode() == e.GetToNode()) {num++;}
            e = e.NextEdge;
        }
        return num;
    }

  //methods
  //#######################################################
  Node AddNode(int x, int y, int mod, int id, int color, int index, int level, int sublevel, String name){
      //vytvori novy uzel grafu
      Node N = new Node(x, y, mod, id, color, index, level, sublevel, name, null, null, null); //id stat.prom.tridy
      //pokud je prvnim uzlem grafu, nastavi se jako prvni i posledni
      if (LastNode==null) {
          FirstNode = N;
          N.NextNode = null;
          LastNode = N;
      }
      //pokud neni prvnim uzlem grafu, prida ho na konec seznamu uzlu grafu
      else {
          N.NextNode = LastNode.NextNode;
          LastNode.NextNode = N;
          LastNode = N;
      }
      return N;
  } //end of method AddNode




  //#######################################################
  Edge AddEdge(String value, Node from, Node to){
      // vytvori novou hranu z uzlu do uzlu
      Edge N = new Edge(value, 0, 0, 1, 0, from, to, null, new Vector()); //id stat.prom.tridy
      //pokud to je prvni hrana grafu, nastavi ji jako prvni i posledni v seznamu hran grafu
      if (LastEdge==null) {
          FirstEdge = N;
          N.NextEdge = null;
          LastEdge = N;
      }
      //kazdou dalsi hranu pridava na konec seznamu hran grafu
      else {
          N.NextEdge = LastEdge.NextEdge;
          LastEdge.NextEdge = N;
          LastEdge = N;
      }

      //vlozi odkaz na tuto hranu do seznamu "vystupnich" hran z uzlu
      //najde posledni odkaz na hranu, ktera z uzlu vystupuje
      EdgeListItem LastOutEdge = from.FindLastOutEdge();
      //vytvori novou strukturu - kontejner pro hranu s odkazem na dalsi
      EdgeListItem M = new EdgeListItem();
      //pokud zadna hrana z uzlu nevystupuje, prida se tato nova struktura s novou hranou na zacatek
      if (LastOutEdge==null) {
          from.FirstEdgeOut = M;
          M.NextEdge = null;
          M.FinalEdge = N;
      }
      //pokud nejaka vystupni hrana existuje, prida se tato nova struktura s novou hranou na konec
      else {
          M.NextEdge = LastOutEdge.NextEdge;
          LastOutEdge.NextEdge = M;
          M.FinalEdge = N;
      }

      // vlozi odkaz na tuto hranu do seznamu vstupnich hran do uzlu
      //najde posledni odkaz na hranu, ktera z uzlu vystupuje
      EdgeListItem LastInEdge = to.FindLastInEdge();
      //vytvori novou strukturu - kontejner pro hranu s odkazem na dalsi
      EdgeListItem P = new EdgeListItem();
      //pokud zadna hrana do uzlu nevstupuje, prida se tato nova struktura s novou hranou na zacatek
      if (LastInEdge==null) {
          to.FirstEdgeIn = P;
          P.NextEdge = null;
          P.FinalEdge = N;
      }
      //pokud nejaka vstupni hrana existuje, prida se tato nova struktura s novou hranou na konec
      else {
          P.NextEdge = LastInEdge.NextEdge;
          LastInEdge.NextEdge = P;
          P.FinalEdge = N;
      }
    
    return N;
  } //end of method AddEdge




  //#######################################################
  void DelEdge(Edge e){
      //vymaze odkaz na hranu ze seznamu vystupnich hran uzlu
      //najdu uzel, ze ktereho tato hrana vystupuje
      Node from = e.GetFromNode();
      //a prochazim jeho seznam vystupnich hran
      EdgeListItem Temp = from.FirstEdgeOut;
      EdgeListItem Pred = Temp;
      //pokud je tato rusena hrana prvni v seznamu, vyclenim tuto prvni strukturu
      //rusene hrany a nastavim ji na null
      if(Temp.FinalEdge==e){
          from.FirstEdgeOut = from.FirstEdgeOut.NextEdge;
          Temp = null;
      }
      //jinak prochazim seznam vystupnich hran, dokud nenajdu rusenou hranu,
      //vyclenim tuto strukturu rusene hrany a nastavim ji na null
      else {
          while(Temp.FinalEdge != e){
              Pred = Temp;
              Temp = Temp.NextEdge;
          }
          Pred.NextEdge = Temp.NextEdge;
          Temp = null;
      }

      //vymaze odkaz na hranu ze seznamu vstupnich hran uzlu
      //najdu uzel, do ktereho tato hrana vstupuje
      Node to   = e.GetToNode();
      Temp = to.FirstEdgeIn;
      Pred = Temp;
      //pokud je tato rusena hrana prvni v seznamu, vyclenim tuto prvni strukturu
      //rusene hrany a nastavim ji na null
      if(Temp.FinalEdge==e){
          to.FirstEdgeIn = to.FirstEdgeIn.NextEdge;
          Temp = null;
      }
      //jinak prochazim seznam vstupnich hran, dokud nenajdu rusenou hranu,
      //vyclenim tuto strukturu rusene hrany a nastavim ji na null
      else {
          while(Temp.FinalEdge != e){
              Pred = Temp;
              Temp = Temp.NextEdge;
          }
          Pred.NextEdge = Temp.NextEdge;
          Temp = null;
      }

      //vymazani hrany ze seznamu hran grafu
      Edge Tmp = FirstEdge;
      Edge Pred1 = Tmp;
      //pokud je rusena hrana prvni v seznamu, prehodnim ukazatel
      //na dalsi hranu a tuto vyclenenou hranu nastavim na null
      if(Tmp==e){
          FirstEdge = FirstEdge.NextEdge;
          Tmp = null;
      }
      //jinak prochazim seznam hran grafu az do nalezeni, tuto rusenou hranu
      //vyclenim a nastavim ji na null
      else {
          while(Tmp!=e) {
              Pred1 = Tmp;
              Tmp = Tmp.NextEdge;
          }
          Pred1.NextEdge = Tmp.NextEdge;
          Tmp = null;
      }
  }//end of method DelEdge


//#######################################################
// rusi pouze samotny uzel nikoli navazane hrany
void DelNode(Node n){
//vymazani uzlu ze seznamu uzlu grafu
      Node Tmp = FirstNode;
      Node Pred1 = Tmp;
      //pokud je ruseny uzel prvni v seznamu, prehodnim ukazatel
      //na dalsi uzel a tento vycleneny uzel nastavim na null
      if(Tmp==n){
          FirstNode = FirstNode.NextNode;
          Tmp = null;
      }
      //jinak prochazim seznam uzlu grafu az do nalezeni, ruseny uzel
      //vyclenim a nastavim na null
      else {
          while(Tmp!=n) {
              Pred1 = Tmp;
              Tmp = Tmp.NextNode;
          }
          Pred1.NextNode = Tmp.NextNode;
          Tmp = null;
      }

}


  //#######################################################
  Node FindNode(String Name){
      Node Temp = this.FirstNode;
      while((Temp!=null) && (!Temp.GetName().equals(Name)) ){
          Temp = Temp.NextNode;
      }
      return Temp;
  } //end of method FindNode

  //##########################################################
  void FindOkSuccessors(Node n, Vector v, String z) {

      EdgeListItem n1 = n.FirstEdgeOut;
      while (n1 != null){
          if(n1.FinalEdge.Value != "EPS") {
              if(n1.FinalEdge.Value.equals((String)z)) {
                  v.addElement(new Pair(n1.FinalEdge.ToNode, n1.FinalEdge.Value) );
//                n1.FinalEdge.ToNode.SetColor()
              }
          }
          else {
              FindAllSuccessors(n1.FinalEdge.ToNode, v, z);
          }
          n1 = n1.NextEdge;
      }
  }
  //##########################################################
  void FindAllSuccessors(Node n, Vector v, String z) {

      EdgeListItem n1 = n.FirstEdgeOut;
      while (n1 != null){
          if(n1.FinalEdge.Value != "EPS") {
              //if(n1.FinalEdge.Value.equals((String)z)) {
                  v.addElement(new Pair(n1.FinalEdge.ToNode, n1.FinalEdge.Value) );
//                n1.FinalEdge.ToNode.SetColor()
              //}
          }
          else {
              FindAllSuccessors(n1.FinalEdge.ToNode, v, z);
          }
          n1 = n1.NextEdge;
      }
  }


  //##########################################################
  void DefaultColor(){
      Node Temp = this.FirstNode;
      while(Temp!=null){
          if(Temp.Mod<0){Temp.Color=1;}  //konecny stav RED
          else{Temp.Color=0;}             //default stav BLACK
          Temp = Temp.NextNode;
      }
      Edge e = this.FirstEdge;
      while(e!=null){
            e.SetClr(0);      //default stav BLACK
          e = e.NextEdge;
      }
  } //end of method DefaultColor


  //##########################################################
  //najde x-ove souradnice uzlu nejvice vpravo, tedy max X 
  //deje se tak pro zmenu scrollpane - preferedsize
  int FindMaxX(){
      int maxX = 0;
      Node Temp = this.FirstNode;
      while(Temp!=null){
          if(Temp.GetX()>maxX){ maxX=Temp.GetX(); }  //najde maxX
          Temp = Temp.NextNode;
      }
      return maxX;
  }


  //##########################################################
  //najde y-ove souradnice uzlu nejvice dole, tedy max Y 
  //deje se tak pro zmenu scrollpane - preferedsize
  int FindMaxY(){
      int maxY = 0;
      Node Temp = this.FirstNode;
      while(Temp!=null){
          if(Temp.GetY()>maxY){ maxY=Temp.GetY(); }  //najde maxX
          Temp = Temp.NextNode;
      }
      return maxY;
  }


  //##########################################################
  //najde uzel v blizkosti (d) zadanych souradnic, jinak vraci null;
  Node PointedNode(int x, int y, int d){
      boolean OK = false;
      Node Temp = this.FirstNode;
    
      while(!OK && Temp!=null){
          if(Temp.GetX()-d < x && Temp.GetX()+d > x && Temp.GetY()-d < y && Temp.GetY()+d > y){              
                OK=true;
                break; //vyskoc abych uz neposunul uzel na naslednika
          }
          Temp = Temp.NextNode;
      }
      if(OK){ return Temp; }
      else{ return null; }
  }


  //#########################################################
  //vypacita kontrolni body pro nektere hrany grafu (spliny)
  //pozor this = G
  public void ComputeCtrlPoints(Edge e, Vars VAR) {
        //Edge TempB = this.FirstEdge;
         
       // while(TempB!=null){            
            int A[] = new int[2];
            int B[];
            int C[];
              
            //najde uzly v okne danem uzly From a To, jsou to mozne prekazky
            Vector v = NodesInWindow(e.GetFromNode().GetX(), e.GetFromNode().GetY(),
                                     e.GetToNode().GetX(),e.GetToNode().GetY());  
                               
            //prochazim tento seznam
            while(v.size() > 0) {  
                    
                    //hledam ten, ktery by mohl byt nejblizsi prekazkou
                    int index = Gfx.Nearest(v, e.GetFromNode().GetX(), e.GetFromNode().GetY());
                    A = (int[])v.elementAt(index);
                    
                    //najdu prusecik primky dane uzly From a To a jeji kolmice dane moznou prekazkou - uzlem A 
                    B = Gfx.Intersection( e.GetFromNode().GetX(), e.GetFromNode().GetY(),
                                          e.GetToNode().GetX(), e.GetToNode().GetY(),
                                          A[0], A[1]);   
                    
                    //pokud by prekazka vadila prime usecce, spocita se novy kontrolni bod pro nahradni krivku - spline
                    C = Gfx.NewCtrlPoint(VAR.GetNodeDistance(), e.GetFromNode().GetX(), e.GetFromNode().GetY(),
                                                                e.GetToNode().GetX(), e.GetToNode().GetY(),
                                                                A[0], A[1], B[0], B[1], e.GetCnt(), VAR);
                    
                    //pokud se opravdu jednalo o prekazku, je novy kontrolni bod pridan do seznamu kontrolnich bodu dane hrany
                    if (C[0]!=-1 && C[1]!=-1){
                        e.GetCtrl().addElement(C);
                    }
                    
                    //kontrolovany uzel je proveren, muze byt odebran ze seznamu moznych prekazek
                    v.removeElementAt(index); 
            }//end while
            
            //pokud je seznam kontrolnich bodu prazdny, tedy pokud zadny uzel neprekazi hrane
            //jeste overim kolikata je to hrana mezi temito dvema uzly - vice hran nutno odlisit            
            if(e.GetCtrl().isEmpty()){  //jeste tam nejsou ani samotne stredy From a To uzlu
                //existuje vice hran mezi stejnymi uzly
                if(e.GetCnt()>1){
                    int D[] = new int[2];
                    double t = (e.GetCnt()-1)*VAR.GetEdgeDistance()/Gfx.Distance(e.GetFromNode().GetX(), e.GetFromNode().GetY(), e.GetToNode().GetX(), e.GetToNode().GetY());
                    //x=Px+t*(By-Ay)   y=Py+t*(Ax-Bx)
                    D[0]=(int)(((e.GetFromNode().GetX()+e.GetToNode().GetX())/2) + t*(e.GetToNode().GetY()-e.GetFromNode().GetY()));
                    D[1]=(int)(((e.GetFromNode().GetY()+e.GetToNode().GetY())/2) + t*(e.GetFromNode().GetX()-e.GetToNode().GetX()));
                    e.GetCtrl().addElement(D);
                    //System.out.println("empty: cnt "+TempB.GetCnt()+" "+D[0]+" "+D[1]);
                }
            }
            
            
           // TempB = TempB.NextEdge;
         
       // }//while
         
  } //end of method 



  //##############################################################
  public Vector NodesInWindow(int Ax, int Ay, int Bx, int By){
  //fce najde v danem vyrezu vsechny uzly grafu a vrati je jako vektor 2D poli  
    Vector v = new Vector();
        
    int minX;
    int maxX;
    int minY;
    int maxY;
    
    //nejprve si souradnice vhodne usporadam
    if(Ax>Bx){ maxX=Ax; minX=Bx; } else { maxX=Bx; minX=Ax; }
    if(Ay>By){ maxY=Ay; minY=By; } else { maxY=By; minY=Ay; }
    
    //pokud skutecne existuje graf, prochazim uzly
    if(this!=null){
        Node n = this.FirstNode;
        while(n!=null){
            //nutna i rovnost pro pripad horizontalnich hran
            if(Ay==By && n.GetX()>minX && n.GetX()<maxX && n.GetY()==Ay){
                int A[] = new int[2];
                A[0]=n.GetX();
                A[1]=n.GetY();
                //mozne prekazky pridavam do seznamu
                v.addElement(A);
                //A=null;
            }
            //nutna i rovnost pro pripad vertikalnich hran
            else if(Ax==Bx && n.GetX()==Ax && n.GetY()>minY && n.GetY()<maxY){
                int A[] = new int[2];
                A[0]=n.GetX();
                A[1]=n.GetY();
                //mozne prekazky pridavam do seznamu
                v.addElement(A);
                //A=null;
            }
            //jinak
            else if(n.GetX()>minX && n.GetX()<maxX && n.GetY()>minY && n.GetY()<maxY){
                int A[] = new int[2];
                A[0]=n.GetX();
                A[1]=n.GetY();
                //mozne prekazky pridavam do seznamu
                v.addElement(A);
                //A=null;
            }
            
            
            n = n.NextNode;
        }
        return v;
    }
    else {
        return null;
    }
  
  }



//******************************************************************************
void AddFirstAndLastCtrlPoint(Edge e, Vars VAR){
    int Fx1, Fy1, Tx1, Ty1, Fx2, Fy2, Tx2, Ty2;
    double alpha1 = 0.0, alpha2 = 0.0;
    
        if(e.GetCtrl().size()==0){ 
            Fx1 = e.GetFromNode().GetX();
            Fy1 = e.GetFromNode().GetY();
            Tx1 = e.GetToNode().GetX();
            Ty1 = e.GetToNode().GetY();            
            //zpetny tah
            Fx2 = e.GetToNode().GetX();
            Fy2 = e.GetToNode().GetY();
            Tx2 = e.GetFromNode().GetX();
            Ty2 = e.GetFromNode().GetY();          
        } 
                    
        //pokud mezi uzly From a To lezi nejaka prekazka, spojujeme pomoci sliny 
        else {           
            Fx1 = ((int[])e.GetCtrl().elementAt(e.GetCtrl().size()-1))[0]; //x-souradnice posled. kontrolniho bodu pred stredem uzlu To
            Fy1 = ((int[])e.GetCtrl().elementAt(e.GetCtrl().size()-1))[1]; //y-souradnice posled. kontrolniho bodu pred stredem uzlu To           
            Tx1 = e.GetToNode().GetX(); //x-souradnice stredu To uzlu
            Ty1 = e.GetToNode().GetY(); //y-souradnice stredu To uzlu
             
            Fx2 = ((int[])e.GetCtrl().elementAt(0))[0]; 
            Fy2 = ((int[])e.GetCtrl().elementAt(0))[1]; 
            Tx2 = e.GetFromNode().GetX(); 
            Ty2 = e.GetFromNode().GetY();            
        }
        //znam posledni usecky ci segmenty(Fx,Fy,Tx,Ty)- spocitam jaky svira uhel          
            //vertikala zdola nahoru       
            if(Fx1==Tx1 && Fy1>Ty1){ 
                alpha1 = Math.PI/2; 
            }
            //vertikala shora dolu
            else if(Fx1==Tx1 && Fy1<=Ty1){ 
                alpha1 = Math.PI/2*3; 
            }            
            //zleva doprava
            else if(Fx1 < Tx1){
                alpha1 = Math.PI + Math.atan( (double)(Fy1-Ty1) / (double)(Fx1-Tx1) );
            }    
            //zprava doleva
            else if(Fx1 > Tx1){
                alpha1 = Math.atan( (double)(Fy1-Ty1) / (double)(Fx1-Tx1) );
            }
            
        //znam posledni usecky ci segmenty(Fx,Fy,Tx,Ty)- spocitam jaky svira uhel          
            //vertikala zdola nahoru       
            if(Fx2==Tx2 && Fy2>Ty2){ 
                alpha2 = Math.PI/2; 
            }
            //vertikala shora dolu
            else if(Fx2==Tx2 && Fy2<=Ty2){ 
                alpha2 = Math.PI/2*3; 
            }            
            //zleva doprava
            else if(Fx2 < Tx2){
                alpha2 = Math.PI + Math.atan( (double)(Fy2-Ty2) / (double)(Fx2-Tx2) );
            }    
            //zprava doleva
            else if(Fx2 > Tx2){
                alpha2 = Math.atan( (double)(Fy2-Ty2) / (double)(Fx2-Tx2) );
            }
            
            // dvakrat pridej na konec seznamu kontrolnich bodu koncovy bod
            int[] N = new int[2];
            N[0] = Tx1 + (int)((VAR.GetNodeRadius()/2) * Math.cos(alpha1));
            N[1] = Ty1 + (int)((VAR.GetNodeRadius()/2) * Math.sin(alpha1));
            e.GetCtrl().insertElementAt(N, e.GetCtrl().size()); //vlozi element uplne na posledni misto
            e.GetCtrl().insertElementAt(N, e.GetCtrl().size()); //vlozi element uplne na posledni misto, i pred predchozi
            
            // dvakrat pridej na zacatek seznamu kontrolnich bodu pocatecni bod
            int[] M = new int[2];
            M[0] = Tx2 + (int)((VAR.GetNodeRadius()/2) * Math.cos(alpha2));
            M[1] = Ty2 + (int)((VAR.GetNodeRadius()/2) * Math.sin(alpha2));
            e.GetCtrl().insertElementAt(M, 0); //vlozi na prvni misto
            e.GetCtrl().insertElementAt(M, 0); //vlozi na prvni misto i za predchozi
            
    //System.out.println("F: "+N[0]+" "+N[1]+ "L :"+M[0] +" "+ M[1]);
            
            // compute ARROW
            int[] Arr = new int[6];
            Arr[0] = Tx1 + (int)((VAR.GetNodeRadius()/2) * Math.cos(alpha1));
            Arr[1] = Ty1 + (int)((VAR.GetNodeRadius()/2) * Math.sin(alpha1));
            Arr[2] = Tx1 + (int)((VAR.GetNodeRadius()/2 + 10) * Math.cos(alpha1 - Math.PI/36)); //10 .. delka sipky
            Arr[3] = Ty1 + (int)((VAR.GetNodeRadius()/2 + 10) * Math.sin(alpha1 - Math.PI/36)); //PI/36 .. rozevreni sipky
            Arr[4] = Tx1 + (int)((VAR.GetNodeRadius()/2 + 10) * Math.cos(alpha1 + Math.PI/36));
            Arr[5] = Ty1 + (int)((VAR.GetNodeRadius()/2 + 10) * Math.sin(alpha1 + Math.PI/36));
        
            e.SetArrow(Arr);
            
   /* 
    int[] N = new int[2];
    N[0] = e.GetFromNode().GetX();
    N[1] = e.GetFromNode().GetY();
    
    e.GetCtrl().insertElementAt(N, 0); //vlozi element uplne na prvni misto
    e.GetCtrl().insertElementAt(N, 0); //vlozi element uplne na prvni misto, i pred predchozi
    
    int[] M = new int[2];
    M[0] = e.GetToNode().GetX();
    M[1] = e.GetToNode().GetY();
    
    e.GetCtrl().insertElementAt(M, e.GetCtrl().size()-1); //vlozi na posledni misto
    e.GetCtrl().insertElementAt(M, e.GetCtrl().size()-1); //vlozi na posledni misto i za predchozi
            */
}



//******************************************************************************
public void ComputeArrow(Edge e, Vars VAR){
/*   // Edge TempB = this.FirstEdge;
   // int Fx, Fy, Tx, Ty; //from, to    
   // double alpha = 0.0;    
    
   // while(TempB!=null){
        //pokud mezi From a To uzlem nelezi zadna prekazka, spojujeme pomoci cary (respektive spliny pokud ma vyssi citac nez 1)
        //to se ale resi ve fci ComputeCtrlPoints() pomoci virtualnich kontrolnich bodu
        if(e.GetCtrl().size()==4){ //v kontrolnich bodech je pouze pocatek (dvakrat - kvuli interpolaci i techto bodu) a konec (dvakrat)
            Fx = e.GetFromNode().GetX();
            Fy = e.GetFromNode().GetY();
            Tx = e.GetToNode().GetX();
            Ty = e.GetToNode().GetY();
        } 
                    
        //pokud mezi uzly From a To lezi nejaka prekazka, spojujeme pomoci sliny 
        else {           
            Fx = ((int[])e.GetCtrl().elementAt(e.GetCtrl().size()-3))[0]; //x-souradnice posled. kontrolniho bodu pred stredem uzlu To
            Fy = ((int[])e.GetCtrl().elementAt(e.GetCtrl().size()-3))[1]; //y-souradnice posled. kontrolniho bodu pred stredem uzlu To
            Tx = e.GetToNode().GetX(); //x-souradnice stredu To uzlu
            Ty = e.GetToNode().GetY(); //y-souradnice stredu To uzlu
        }
        
        
        //znam posledni usecku ci segment(Fx,Fy,Tx,Ty) na ktere bude sipka - spocitam jaky svira uhel          
            //vertikala zdola nahoru       
            if(Fx==Tx && Fy>Ty){ 
                alpha = Math.PI/2; 
            }
            //vertikala shora dolu
            else if(Fx==Tx && Fy<=Ty){ 
                alpha = Math.PI/2*3; 
            }            
            //zleva doprava
            else if(Fx < Tx){
                alpha = Math.PI + Math.atan( (double)(Fy-Ty) / (double)(Fx-Tx) );
            }    
            //zprava doleva
            else if(Fx > Tx){
                alpha = Math.atan( (double)(Fy-Ty) / (double)(Fx-Tx) );
            }
        

            //System.out.println(alpha);
            //Tx = TempB.GetToNode().GetX() + (int)(VAR.GetNodeRadius()/2 * Math.cos(alpha));
            //Ty = TempB.GetToNode().GetY() + (int)(VAR.GetNodeRadius()/2 * Math.sin(alpha));
            //System.out.println("Tx " + Tx);
            //System.out.println("Ty " + Ty);                          
        
        int[] Arr = new int[6];
        Arr[0] = Tx + (int)((VAR.GetNodeRadius()/2) * Math.cos(alpha));
        Arr[1] = Ty + (int)((VAR.GetNodeRadius()/2) * Math.sin(alpha));
        Arr[2] = Tx + (int)((VAR.GetNodeRadius()/2 + 10) * Math.cos(alpha-Math.PI/36)); //10 .. delka sipky
        Arr[3] = Ty + (int)((VAR.GetNodeRadius()/2 + 10) * Math.sin(alpha-Math.PI/36)); //PI/36 .. rozevreni sipky
        Arr[4] = Tx + (int)((VAR.GetNodeRadius()/2 + 10) * Math.cos(alpha+Math.PI/36));
        Arr[5] = Ty + (int)((VAR.GetNodeRadius()/2 + 10) * Math.sin(alpha+Math.PI/36));
        
        e.SetArrow(Arr);
        
       // TempB = TempB.NextEdge;         
  //  }//while
*/            
} //end of method ComputeArrow()


//******************************************************************************
void SetEdgeCounter(Edge e){
    int num;
    if( (num = NumEdgesFromTo(e.GetFromNode(), e.GetToNode()) ) > 1 ) {
        e.SetCnt(num); //pokud tato zadana hrana neni jedina spojnice mezi uzly, inkrementuju citac
    }
}

//******************************************************************************
int NumEdgesFromTo(Node n0, Node n1){
    //najde pocet hran spojujicich zadane dva uzly (v obou smerech)
    Edge e = this.FirstEdge;
    int num = 0;
        while(e!=null){
            if( (e.GetFromNode()==n0 && e.GetToNode()==n1) || (e.GetFromNode()==n1 && e.GetToNode()==n0)){num++;}
            e = e.NextEdge;
        }
    return num;
}
//******************************************************************************




} //end of class Graph
