package diploma;
import java.lang.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;

public class GraphMaker extends Object {

//datove polozky
//private int level_x = 0;
//private int level_y = 0;
static int j = 0;
Vars VAR;


//constructor
GraphMaker(Vars VAR){
    this.VAR = VAR;
}




//methods
void clear(Graph G) {
//  level_x = level_y = 0;
  G.FirstNode = null;
  G.LastNode  = null;
  G.FirstEdge = null;
  G.LastEdge  = null;
  System.gc();
}


void create(Analyzer A, Graph G) {
Node q0, q1, q2;
Edge e0, e1, e2;
int num;
VAR.SetNodeCounter(0);  //vytvarim novy graf, zacnu cislovat od zacatku (od nuly)

//pridej stav "start" (x,y,mod,id,color, index,level,sublevel,name)
  q0 = G.AddNode(VAR.GetStartPositionX(), 
                 VAR.GetStartPositionY(), 
                 0, VAR.GetNodeCounter(), 0, 
                 -1, 0, 0, "START");
  VAR.IncrementNodeCounter();

//pridej mnozinu pocatecnich stavu
    for(int i=0; i<A.is.size(); i++){
                
        StringTokenizer st = new StringTokenizer((String)A.is.elementAt(i),"+");
        String Znak = (String)st.nextToken();
        Znak = Analyzer.ReMap(Znak);
        int Index  = Integer.parseInt(st.nextToken())+1;
        int Level  = Integer.parseInt(st.nextToken());
        int Sublevel = Integer.parseInt(st.nextToken());
        
        q1 = G.AddNode(VAR.GetStartPositionX() + VAR.GetStepX(), 
                       VAR.GetStartPositionY() + ( ((G.Errors+1) * VAR.GetStepY()) * Level), 
                       1, VAR.GetNodeCounter(), 0, 
                       0, Level, 0, 
                       "EPS(0,"+String.valueOf(Level)+",0)");
        VAR.IncrementNodeCounter();
        
        e1 = G.AddEdge("EPS", q0, q1);
        G.SetEdgeCounter(e1);    
        //G.ComputeCtrlPoints(e1, VAR);    
        //G.AddFirstAndLastCtrlPoint(e1, VAR);
        
        
        q2 = G.AddNode(VAR.GetStartPositionX() + VAR.GetStepX() + (VAR.GetStepX() * Index), 
                       VAR.GetStartPositionY() + ( ((G.Errors+1) * VAR.GetStepY()) * Level) + Sublevel * VAR.GetStepY(), 
                       1, VAR.GetNodeCounter(), 0, 
                       Index, Level, Sublevel,
                       Znak+"("+String.valueOf(Index)+","+String.valueOf(Level)+","+String.valueOf(Sublevel)+")");
        VAR.IncrementNodeCounter();
        
        e2 = G.AddEdge(Znak, q1, q2);        
        G.SetEdgeCounter(e2);    
        //G.ComputeCtrlPoints(e2, VAR);    
        //G.AddFirstAndLastCtrlPoint(e2, VAR);    
        //G.ComputeArrow(e0, VAR);
    }

//pridej mnozinu sousedu
  for(int i=0; i<A.ns.size(); i++){
    StringTokenizer st = new StringTokenizer((String)A.ns.elementAt(i),"+");
    //////
    //System.out.println((String)A.ns.elementAt(i));
    
    String Znak1 = (String)st.nextToken();
    Znak1 = Analyzer.ReMap(Znak1);
    int Index1  = Integer.parseInt(st.nextToken())+1;
    int Level1  = Integer.parseInt(st.nextToken());
    int Sublevel1 = Integer.parseInt(st.nextToken());
    
    String Znak2 = (String)st.nextToken();
    Znak2 = Analyzer.ReMap(Znak2);
    int Index2  = Integer.parseInt(st.nextToken())+1;
    int Level2  = Integer.parseInt(st.nextToken());
    int Sublevel2 = Integer.parseInt(st.nextToken());
    
    q0 = G.FindNode(Znak1+"("+String.valueOf(Index1)+","+String.valueOf(Level1)+","+String.valueOf(Sublevel1)+")");
    if( (q1 = G.FindNode(Znak2+"("+String.valueOf(Index2)+","+String.valueOf(Level2)+","+String.valueOf(Sublevel2)+")")) == null ) {
         q1 = G.AddNode(VAR.GetStartPositionX() + VAR.GetStepX() + (VAR.GetStepX() * Index2), 
                        VAR.GetStartPositionY() + ( ((G.Errors+1) * VAR.GetStepY()) * Level2) + Sublevel2 * VAR.GetStepY(), 
                        1, VAR.GetNodeCounter(), 0, Index2, Level2, Sublevel2,
                        Znak2+"("+String.valueOf(Index2)+","+String.valueOf(Level2)+","+String.valueOf(Sublevel2)+")");
        VAR.IncrementNodeCounter();
    }
    e0 = G.AddEdge(Znak2, q0, q1);
    //pokud uz nejake hrany z uzlu q0 do q1 existuji, zvednu citac teto hrany o jejich pocet+1 a
    //pridam kontrolni bod aby byla vykreslena jako spline
    G.SetEdgeCounter(e0);    
    //G.ComputeCtrlPoints(e0, VAR);    
    //G.AddFirstAndLastCtrlPoint(e0, VAR);
    
   // G.ComputeArrow(e0, VAR);
    //if( (num = ExistEdgeFromTo(G,q0,q1)) > 1 ) {
    //    e0.SetCnt(num);
    //}
  }

//oznac koncove stavy
  for(int i=0; i<A.fs.size(); i++){
    StringTokenizer st = new StringTokenizer((String)A.fs.elementAt(i),"+");
    String Znak = (String)st.nextToken();
    Znak = Analyzer.ReMap(Znak);
    int Index  = Integer.parseInt(st.nextToken())+1;
    int Level  = Integer.parseInt(st.nextToken());
    int Sublevel = Integer.parseInt(st.nextToken());
    
    q0 = G.FindNode(Znak+"("+String.valueOf(Index)+","+String.valueOf(Level)+","+String.valueOf(Sublevel)+")");
    q0.SetMod(q0.GetMod()*(-1));
    q0.SetColor(1);
  }
} //end of method




//******************************************************************************
void UpdateEdgeCoords(Graph G){
    Edge e = G.FirstEdge;
        while(e!=null){
            G.ComputeCtrlPoints(e, VAR);    
            G.AddFirstAndLastCtrlPoint(e, VAR);            
            e = e.NextEdge;
        }
}    



//******************************************************************************
/*
int ExistEdgeFromTo(Graph G, Node q0, Node q1){
    Edge e = G.FirstEdge;
    int num = 0;
        while(e!=null){
            if( (e.GetFromNode()==q0 && e.GetToNode()==q1) || (e.GetFromNode()==q1 && e.GetToNode()==q0)){num++;}
            e = e.NextEdge;
        }
    return num;
}

*/



//******************************************************************************
void modify(Graph G, int[] si){
    
    G.setErrors(si[6]);
    this.modify1(G, si[0]); //string | sequence
    //3 znamo jiz pri parsovani
    this.modify4(G, si[3]); //E | R | DIR | DIRT
    this.modify2(G, si[1]); //full | subpattern    -- az po aprox.modify --v aprox.modify by se nekopirovaly hrany z START uzlu
    //5 znamo jiz pri parsovani
    this.modify6(G, si[5]); // one | sequence
    
    //this.updateCoords(G);
    
}

//******************************************************************************
void modify1(Graph G, int si){
    //projdi vsechny uzly a pridej smycku vsem uzlum z kterych vychazi nejaka hrana (pres vsechny jine znaky nez ktere vychazeji)
    if(si==1){
      //  System.out.println("Modifikace grafu: 1.par. seQuence\n");
        
        //projdi vsechny hrany a smaz ty, ktere jsou smyckami
      /*Edge e = G.FirstEdge;
        while(e != null) {
            if(e.FromNode == e.ToNode) { 
                G.DelEdge(e);
            }
            e=e.NextEdge;
        }
        */
        Node n = G.FirstNode;
        while(n != null) {
            if(!n.GetName().equals("START")){
                String s = "";
                Vector v = GetAllOutChars(n); //najdi vsechny znaky pod kterymi je mozny prechod z uzlu
                if(v.size()>0){ //pokud existuje nejaka odchozi hrana
                    for(int i=0; i<v.size(); i++){
                        s = s.concat("!"+(String)v.elementAt(i));
                    }
                    G.SetEdgeCounter(G.AddEdge(s, n, n));
                }
            }
            n=n.NextNode;            
        }
    }
}

//******************************************************************************
Vector GetAllOutChars(Node n){
    Vector v = new Vector();
    EdgeListItem out = n.GetFirstEdgeOut();
    while(out != null){
        String s = out.FinalEdge.GetValue();
        if(!v.contains(s)) {v.addElement(s);}
       // System.out.println("pridavam "+ out.FinalEdge.GetValue());
        out = out.NextEdge;
    }    
   // System.out.println("Outing");
    return v;
}

//******************************************************************************
void modify2(Graph G, int si){
    if(si==1){
        Node n, start;
        start = G.FindNode("START");
        n = G.FirstNode;
        while(n!=null){
            if(!n.GetName().equals("START")){
                if(FindEdge(G,start,n,"EPS")==null){
                    G.SetEdgeCounter(G.AddEdge("EPS", start, n));
                }
                n.SetMod(n.GetMod()*(-1));
                n.SetColor(1);
            }
            n=n.NextNode;
        }
    }    
}
//******************************************************************************
void modify4(Graph G, int si){
if(si==1 || si==2 || si==3){    //R-match, DIR-match, DIRT-match
    Node n, nd, nod, node, n1, n2, n3;
    Edge e;
    // ****** 1. pridat uzly *****
    n = G.FirstNode;
    while(n!=null){
        if(!n.GetName().equals("START") && n.GetSublevel()==0){
            for(int i=1; i<=G.getErrors(); i++){
                //(x,y,mod,id,color, index,level,sublevel,name)
                G.AddNode(n.GetX(), n.GetY()+i*VAR.GetStepY(), n.GetMod(), VAR.GetNodeCounter(), n.GetColor(), 
                          n.GetIndex(), n.GetLevel(), n.GetSublevel()+i, 
                          "SUB("+String.valueOf(n.GetIndex())+","+String.valueOf(n.GetLevel())+","+String.valueOf(n.GetSublevel()+i)+")");
                VAR.IncrementNodeCounter();
            }
        }
        n=n.NextNode;
    }
    
    //2. pridat hrany
    n = G.FirstNode;
    while(n!=null){
        if(!n.GetName().equals("START") && n.GetSublevel()==0){
            Vector outedges = GetOutEdges(n);
            //Vector inedges  = GetInEdges(n);
            for(int j=1; j<=G.getErrors(); j++){
                node = FindNode(G, n.GetIndex(), n.GetLevel(), n.GetSublevel()+j);
                for(int i=0; i<outedges.size(); i++){
                    e = (Edge)outedges.elementAt(i);
                    n2 = FindNode(G, e.GetToNode().GetIndex(), e.GetToNode().GetLevel(), e.GetToNode().GetSublevel()+j);
                    G.SetEdgeCounter(G.AddEdge(e.GetValue(), node, n2));
                }
               /* 
                for(int i=0; i<inedges.size(); i++){
                    e = (Edge)inedges.elementAt(i);
                    if(!e.GetFromNode().GetName().equals("START")){ //nekopiruji se hrany z uzlu START
                        n2 = FindNode(G, e.GetFromNode().GetIndex(), e.GetFromNode().GetLevel(), e.GetFromNode().GetSublevel()+j);
                        G.SetEdgeCounter(G.AddEdge(e.GetValue(), n2, node));
                    }
                }
                */                
            }            
        }
        n=n.NextNode;
    }
    
    //pridat spoje
    n = G.FirstNode;
    while(n!=null){
        if(!n.GetName().equals("START")){
            node = FindNode(G, n.GetIndex()+1, n.GetLevel(), n.GetSublevel());
            if(node != null){
                String s = FindEdge(G, n, node).GetValue();
                n2 = FindNode(G, n.GetIndex()+1, n.GetLevel(), n.GetSublevel()+1);
                if(n2 != null){
                    G.SetEdgeCounter(G.AddEdge("!"+s, n, n2));  //spoj i,j ---> i+1,j+1  replace  (pro R,DIR,DIRT)
                    if(si==2 || si==3){ //hrany 'delete' se zobrazi pouze pro volby DIR, DIRT
                        G.SetEdgeCounter(G.AddEdge("EPS", n, n2));  //delete                          (pro DIR,DIRT)
                    }
                }
                    if(si==2 || si==3){ //hrany 'insert' se zobrazi pouze pro volby DIR, DIRT
                        n2 = FindNode(G, n.GetIndex(), n.GetLevel(), n.GetSublevel()+1);
                        if(n2 != null){
                            G.SetEdgeCounter(G.AddEdge("!"+s, n, n2));  //spoj i,j ---> i,j+1   insert     (pro DIR,DIRT)
                        }
                    }
            }
        }
        n=n.NextNode;
    }
    
     
    
    //pridat TRANSPOZICNI hranu
if(si==3){ //jen pro volbu DIRT
    nd = G.FirstNode;
    while(nd!=null){
        if(!(nd.GetName().equals("START")) && (nd.GetSublevel()>=0) ){
            if( (nod = FindNode(G, nd.GetIndex()+2, nd.GetLevel(), nd.GetSublevel()+1)) != null){
                //pridej uzel (x,y,mod,id,color, index,level,sublevel,name)
                n3 = G.AddNode(nd.GetX() + (int)Math.abs(nd.GetX()-nod.GetX())/3, 
                               VAR.GetStartPositionY() + ( ((G.getErrors()+1) * VAR.GetStepY()) * nd.GetLevel()) + nd.GetSublevel() * VAR.GetStepY() + (int)Math.abs(nd.GetY()-nod.GetY())/3, 
                               0, VAR.GetNodeCounter(), 0, 
                               nd.GetIndex()+1, nd.GetLevel(), nod.GetSublevel()*(-1),  
                               "TRANS("+String.valueOf(nd.GetIndex()+1)+","+String.valueOf(nd.GetLevel())+","+String.valueOf(nod.GetSublevel()*(-1))+")");
               // System.out.println(VAR.GetNodeCounter()+": " + String.valueOf(nd.GetX() + (int)Math.abs(nd.GetX()-nod.GetX())/3)+" | "+String.valueOf(VAR.GetStartPositionY() + ( ((G.getErrors()+1) * VAR.GetStepY()) * nd.GetLevel()) + nd.GetSublevel() * VAR.GetStepY() + (int)Math.abs(nd.GetY()-nod.GetY())/3) );
                VAR.IncrementNodeCounter();
                
                //pridej hrany
                if( (n1 = FindNode(G, nd.GetIndex()+1, nd.GetLevel(), nd.GetSublevel())) == null){ System.out.println("n+1 NENALEZEN");}
                String s1 = FindEdge(G, nd, n1).GetValue();
                if( (n2 = FindNode(G, nd.GetIndex()+2, nd.GetLevel(), nd.GetSublevel())) == null){ System.out.println("n+2 NENALEZEN");}
                String s2 = FindEdge(G, n1, n2).GetValue();
                G.SetEdgeCounter(G.AddEdge(s2, nd, n3));
                G.SetEdgeCounter(G.AddEdge(s1, n3, nod));
                               
            }else{
               // System.out.println("n+2+1 NENALEZEN" + nd.GetIndex() +  nd.GetLevel() + nd.GetSublevel());
            }
        }
        nd=nd.NextNode;
    }
}
    



   //vymazat nepotrebne uzly (vcetne jeho hran)
   /*
    int maxlevel= FindMaxLevel(G);
    for(int m = 0; m<=maxlevel; m++){        //level
        for(int s=1; s<=G.getErrors(); s++){ //sublevel
            for(int j=0; j<s; j++){          //index
                if( (n=FindNode(G,j,m,s)) != null ){
                
                    //mazani uzlu n
                    Vector outedges = GetOutEdges(n);
                    for(int i=0; i<outedges.size(); i++){
                        G.DelEdge( (Edge)outedges.elementAt(i));                    
                    }
                    Vector inedges =  GetInEdges(n);
                    for(int i=0; i<inedges.size(); i++){
                        G.DelEdge( (Edge)inedges.elementAt(i));                    
                    }
                    
                    G.DelNode(n);
                }
                
                if( (n=FindNode(G,j+1,m,-s-1)) != null ){
                
                    
                    //mazani uzlu n
                    Vector outedges = GetOutEdges(n);
                    for(int i=0; i<outedges.size(); i++){
                        G.DelEdge( (Edge)outedges.elementAt(i));                    
                    }
                    Vector inedges =  GetInEdges(n);
                    for(int i=0; i<inedges.size(); i++){
                        G.DelEdge( (Edge)inedges.elementAt(i));                    
                    }
                    
                    G.DelNode(n);
                }
            }
        }
    }

*/


}//endif si=1,2,3

}



//******************************************************************************

  //vymazat nepotrebne uzly (vcetne jeho hran)
void DeleteNodes(Graph G){
    Node n;
    
    int maxlevel= FindMaxLevel(G);
    for(int m = 0; m<=maxlevel; m++){        //level
        for(int s=1; s<=G.getErrors(); s++){ //sublevel
            for(int j=0; j<s; j++){          //index
                if( (n=FindNode(G,j,m,s)) != null ){
                
                    //mazani uzlu n
                    Vector outedges = GetOutEdges(n);
                    for(int i=0; i<outedges.size(); i++){
                        G.DelEdge( (Edge)outedges.elementAt(i));                    
                    }
                    Vector inedges =  GetInEdges(n);
                    for(int i=0; i<inedges.size(); i++){
                        G.DelEdge( (Edge)inedges.elementAt(i));                    
                    }
                    
                    G.DelNode(n);
                }
                
                if( (n=FindNode(G,j+1,m,-s-1)) != null ){
                
                    
                    //mazani uzlu n
                    Vector outedges = GetOutEdges(n);
                    for(int i=0; i<outedges.size(); i++){
                        G.DelEdge( (Edge)outedges.elementAt(i));                    
                    }
                    Vector inedges =  GetInEdges(n);
                    for(int i=0; i<inedges.size(); i++){
                        G.DelEdge( (Edge)inedges.elementAt(i));                    
                    }
                    
                    G.DelNode(n);
                }
            }
        }
    }
}


//******************************************************************************
void modify6(Graph G, int si){
    Node start, end;
    if(si==1){
        //System.out.println("Modifikace grafu: 6.par. seQuence\n");
        int maxindex = FindMaxIndex(G);
                
        end = G.AddNode(VAR.GetStartPositionX()+ 3*VAR.GetStepX() + VAR.GetStepX() * maxindex, 
                       VAR.GetStartPositionY(), 
                       0, VAR.GetNodeCounter(), 0, 
                       -1, 0, 0, "END");
        
        Node n = G.FirstNode;
        while(n!=null){
            if(n.GetMod() < 0){           
                G.SetEdgeCounter(G.AddEdge("EPS", n, end));
            }
            n = n.NextNode;
        }
        
        start = G.FindNode("START");
        G.SetEdgeCounter(G.AddEdge("EPS", end, start));
    }
}


//******************************************************************************
Edge FindEdge(Graph G, Node n1, Node n2){
    boolean found = false;
    Edge ret = null;
    Edge e = G.FirstEdge;
    while(e != null) {
      if(e.GetFromNode() == n1 && e.GetToNode()==n2) { ret = e; found = true; break;}
      e=e.NextEdge;
    }
    if(found) return ret;
    else return null;
}

//******************************************************************************
Edge FindEdge(Graph G, Node n1, Node n2, String s){
    boolean found = false;
    Edge ret = null;
    Edge e = G.FirstEdge;
    while(e != null) {
      if(e.GetFromNode() == n1 && e.GetToNode()==n2 && e.GetValue().equals(s)) { ret = e; found = true; break;}
      e=e.NextEdge;
    }
    if(found) return ret; 
    else return null;
}



//******************************************************************************
Vector GetOutEdges(Node n){
    Vector v = new Vector();
    EdgeListItem eli = n.GetFirstEdgeOut();
    while(eli != null){
        v.addElement(eli.FinalEdge);
        eli = eli.NextEdge;
    }
    return v;
}


//******************************************************************************
Vector GetInEdges(Node n){
    Vector v = new Vector();
    EdgeListItem eli = n.GetFirstEdgeIn();
    while(eli != null){
        v.addElement(eli.FinalEdge);
        eli = eli.NextEdge;
    }
    return v;
}


//******************************************************************************
Node FindNode(Graph G, int index, int level, int sublevel){
    boolean found = false;
    Node ret = null;
    Node n = G.FirstNode;
    while(n!=null){
        if(n.GetIndex()==index && n.GetLevel()==level && n.GetSublevel()==sublevel) { ret = n; found=true; break;}            
        n=n.NextNode;
    }
    if(found) return ret; 
    else return null;
}


//******************************************************************************
int FindMaxIndex(Graph G){
    int maxindex=0;
    Node n = G.FirstNode;
        while(n != null) {
            if(n.GetIndex()>maxindex){maxindex = n.GetIndex();}
            n=n.NextNode;            
        }
    return maxindex;
}

//******************************************************************************
int FindMaxLevel(Graph G){
    int maxlevel=0;
    Node n = G.FirstNode;
        while(n != null) {
            if(n.GetLevel()>maxlevel){maxlevel = n.GetLevel();}
            n=n.NextNode;            
        }
    return maxlevel;
}




//******************************************************************************
void updateCoords(Graph G){
    Node n = G.FirstNode;
    while(n != null) {
        if(n.GetSublevel()>=0){  
            n.SetY(VAR.GetStartPositionY() + ( ((G.Errors+1) * VAR.GetStepY()) * n.GetLevel()) + n.GetSublevel() * VAR.GetStepY());
        }
        n=n.NextNode;
    }
}

//******************************************************************************
int CheckMinIndex(Graph G){
    int min=0;
 /*   Node n = G.FirstNode;
    int min=n.GetIndex();
    while(n != null) {
        if(n.GetIndex()<min) {min=n.GetIndex();}
      n=n.NextNode;
    }
*/
    return min;
}



/*
void modify(Graph G, int si1, int si2, int si3, int si4, int si5, int si6){
  System.out.println(si1+" "+si2+" "+si3+" "+si4+" "+si5+" "+si6);

  //modifikuj dle volby "Nature of the pattern: string, sequence" pouze pokud je
  //nastavena sequence; string je defaultni vysledek vytvoreni grafu
  if(si1==1){

    //projdi vsechny hrany a smaz ty, ktere jsou smyckami
    Edge e = G.FirstEdge;
    while(e != null) {
      if(e.FromNode == e.ToNode) { G.DelEdge(e);}
      e=e.NextEdge;
    }

    //projdi vsechny uzly a u vsech nekoncovych pridej smycku pres "cokoli"
    Node n = G.FirstNode;
    while(n != null) {
      if(n.GetMod() >= 0) { G.AddEdge("don't care",n,n); }
      n=n.NextNode;
    }
  }
}
*/
/*
void modify2(Graph G, Parser P){  //prevede iteracni cykly na epsilon-kroky a smycky
  Node Temp;
  //projdi cely ocislovany pattern, pokud je za znakem *, vchazi se do nej epsilon-krokem a ma smycku
  for(int i=0; i<P.vect.size(); i++){
        if(P.vect.elementAt(i).equals("*")){
            Temp = G.FindNode(P.vect.elementAt(i-1).toString());
            //projdi vsechny vstupni hrany do uzlu a prepis je na EPsilon prechody
            EdgeListItem eli = Temp.FirstEdgeIn;
            while(eli != null) {
              if(eli.FinalEdge.FromNode != eli.FinalEdge.ToNode) { eli.FinalEdge.SetValue("EPS");}
              eli=eli.NextEdge;
            }
        }
  }
}


void modify3(Graph G, int si2){   //prevede graf na subsequences, ze START uzlu je mozno dostat se do lib.uzlu EPS krokem
  if(si2==1){

    //projdi vsechny uzly, oznac je jako koncove, pridej do nej hranu ze START pres EPS"
    Node start = G.FindNode("START");
    Node n = G.FirstNode;
    while(n != null) {
      if(n.GetMod() >= 0){
          n.SetMod(n.GetMod()*(-1));
      }
      G.AddEdge("EPS",start,n);
      n=n.NextNode;
    }
  }
} //end of method
*/

/*
void modify6(Graph G, int si6){
  if(si6==1){

    Node end = G.AddNode(VAR.GetStartPositionX() + 5 * VAR.GetStepX(), VAR.GetStartPositionY() + 5 * VAR.GetStepY(), 0, 0, 0, "END");
    Node start = G.FindNode("START");
    //projdi vsechny uzly, koncove pripoj pres EPS do END, pridej hranu ze END do START pres EPS"
    Node n = G.FirstNode;
    while(n != null) {
      if(n.GetMod() < 0){
          G.AddEdge("EPS",n,end);
      }
      n=n.NextNode;
    }
    G.AddEdge("EPS",end,start);
  }
} //end of method
*/


/*
boolean visualize2(String text, Graph G, javax.swing.JTextPane jTextPane1){

  return true;
} //end of method

*/


























/*

boolean visualize1(Graph G, JTextPane jTextPane1, MyPanel myPanel1){

    String text = jTextPane1.getText();
    String z;  //aktualni znak/pozice v textu
    Vector v1 = new Vector(); //uzly ve v1 se v cyklu prochazeji
    v1.clear();
    Vector v2 = new Vector(); //na zaklade zkoumani v1 se vytvori vektor nasledniku v2 a v2 se prekopiruje do v1 atd.
    //v2.clear();
    int k=0; //iterator posouvani znaku
    //obarvit strat
    boolean ACCEPT = false;
    boolean NEXT = false;


    for(int j=0; j<text.length(); j++){     //posouva text po znacich, mozno pouzit efektivni metodu
            k=j;
            z=String.valueOf(text.charAt(j));  //aktualni znak v textu
            System.out.println("Aktualni znak: " + z + "\n");
            ColorizeText(j,k,jTextPane1);
            G.DefaultColor(); //nastavi barvy uzlu na default (vse cerne, konecne stavy cervene)
             System.out.println("Defaultni barvy");
           // try{ java.lang.Thread.sleep(500); } catch(InterruptedException e){ }
            v1.clear();
            v1.addElement(new Pair(G.FindNode("START"), "START"));
            System.out.println("Do seznamu 'v1' pridan uzel: " + ((Pair)v1.lastElement()).Print() + "\n");

        do{       //hledani shody, pocinaje znakem z
            for(int i=0; i<v1.size(); i++){

                try{ java.lang.Thread.sleep(1000);} catch(InterruptedException e) { }

                ((Pair)v1.lastElement()).GetNode().SetColor(4);    //obarveni aktualniho uzlu


                 //X.repaint(((Pair)v1.lastElement()).GetNode().X-20,((Pair)v1.lastElement()).GetNode().Y-20,((Pair)v1.lastElement()).GetNode().X+20,((Pair)v1.lastElement()).GetNode().Y+20);
                 System.out.println("Obarveni aktualniho uzlu");

              //  try{ java.lang.Thread.sleep(1000);} catch(InterruptedException e) { }

                if(((Pair)v1.elementAt(i)).GetNode().GetMod()<0){ //stav automatu je konecny, vzorek je akceptovan,postupne vyskakuju z cyklu !!
                    System.out.println("Konecny stav\n");
                    v2.clear();
                    ACCEPT = true;
                    System.out.println("break1\n");
                    break;//z for
                }
                else{  //stav neni konecny, hledam vhodne nasledniky
                   System.out.println("FASuccessors\n");
                    G.FindAllSuccessors(((Pair)v1.elementAt(i)).GetNode(), v2, z);   //stav neni konecny, proveruju nasledniky
                }
            }
            if(ACCEPT){ System.out.println("break2"); break;} //jsem v konecnem stavu, akceptuji, vyskakuju z cyklu

            //ok byli nalezeni nejaci naslednici
            if(!v2.isEmpty() && text.length() > k){
                System.out.println("v2 non empty and some text\n");
                for(int i=0; i<v2.size(); i++){
                    ((Pair)v2.elementAt(i)).GetNode().SetColor(2);
                     //pomalu vykresluju nasledniky v grafu
                    try{ java.lang.Thread.sleep(1000);} catch(InterruptedException e) { }
                     System.out.println("Obarvuju: " + ((Pair)v2.elementAt(i)).Print() + "\n");
                     myPanel1.repaint(((Pair)v1.lastElement()).GetNode().X-20,((Pair)v1.lastElement()).GetNode().Y-20,((Pair)v1.lastElement()).GetNode().X+20,((Pair)v1.lastElement()).GetNode().Y+20);
                }
                //projity vektor uzlu bude zapomenut, ted budu prochazet v2 zkopirovane do v1
                 System.out.println("Kopiruju v2 do v1, v2 mazu");
                v1 = (Vector)v2.clone();
                v2.clear();
                k++;          //iterator ktery vychazi z aktualni master-pozice (j) v textu, j se ted nemeni, j=k, pokud se tedy shoduji
                              //j-pozice textu s vzorkem, pok kontroluju postupne dokud to ma smysl pozice j+1, j+2 coz je prave inkrement k++
              //  ColorizeText(j,k,jTextPane1);

                if(text.length()>k) {
                    z = String.valueOf(text.charAt(k));
                    System.out.println("Promenna k je: " + k + "znak: " + z + "\n");
                }
                NEXT = true;
            }
            else{   //iterace pomoci 'k' nema smysl, mohu posunout master pozici 'j'
                if(v2.isEmpty()) {System.out.println("v2 is empty\n");}
                else{System.out.println("none text\n");}
                NEXT = false;
            }

        } while(NEXT);

        if(ACCEPT){ System.out.println("break3\n"); break;}

    } //end for


return ACCEPT;

}//end of run()




void ColorizeText(int j, int k, javax.swing.JTextPane jTextPane1){
      String s="";
      String pole[] ={"","","",""}; //normal, master-pozice, matches, normal
      String styl[] ={"regular","italic","bold","small"};

      Document doc = jTextPane1.getDocument();
            try {
              s = doc.getText(0,doc.getLength());
              pole[0]=s.substring(0,j);
              pole[1]=s.substring(j,j+1);
              pole[2]=s.substring(j+1,k+1);
              pole[3]=s.substring(k+1);
              initStylesForTextPane(jTextPane1);
              //doc.remove(0,doc.getLength());
              for (int i=0; i < pole.length; i++) {
                doc.insertString(doc.getLength(), pole[i]+"\n", jTextPane1.getStyle(styl[i]));
              }
            }
            catch (BadLocationException ble) {
              System.err.println("Couldn't get text.");
            }
}




protected void initStylesForTextPane(javax.swing.JTextPane jTextPane1) {
        //Initialize some styles.
        Style def = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);

        Style regular = jTextPane1.addStyle("regular", def);     //1
        StyleConstants.setFontFamily(def, "SansSerif");

        Style s = jTextPane1.addStyle("italic", regular);       //2
        StyleConstants.setItalic(s, true);
        StyleConstants.setForeground(s, Color.red);

        s = jTextPane1.addStyle("bold", regular);               //3
        StyleConstants.setBold(s, true);
        StyleConstants.setForeground(s, Color.blue);

        s = jTextPane1.addStyle("small", regular);              //4
        StyleConstants.setFontSize(s, 10);
        StyleConstants.setForeground(s, Color.green);
    }
*/


} //end of class GraphMaker
