package gfx;
import java.awt.*;
import java.util.*;
import diploma.*;

public class Gfx extends Object {

    /** Creates new Loop */
    public Gfx() {
            super();
    }

    
    
     public static int[][] LoopControlPoints(int x, int y, int r, int alpha, int delta, int num){
    //stred kruznice uzlu, polomer, smerovy uhel, rozptyl, kolikata stejna smycka
    //vygeneruje pole ridicich bodu smycky pro Catmul-Rom Spline
        int A[][]    = new int[7][2];  //pole pro prenos bodu
        int middle[] = new int[2];
        int left[]   = new int[2];
        int right[]  = new int[2];
        
        double a = Math.PI * alpha / 180; //prevod na radiany
        double d = Math.PI * delta / 180;
        
        middle[0]=(int)(r*Math.cos(a));         middle[1]=(int)(r*Math.sin(a));
        left[0]  =(int)(r*Math.cos(a-d/2));     left[1]  =(int)(r*Math.sin(a-d/2));
        right[0] =(int)(r*Math.cos(a+d/2));     right[1] =(int)(r*Math.sin(a+d/2));
        
        A[0][0]=x;                              A[0][1]=y;      //tyto krajni body se nebudou interpolovat
        A[1][0]=x+left[0];                      A[1][1]=y+left[1];
        A[2][0]=x+(1+num)*left[0];              A[2][1]=y+(1+num)*left[1];
        A[3][0]=(int)(x+(1.3+num)*middle[0]);   A[3][1]=(int)(y+(1.3+num)*middle[1]);
        A[4][0]=x+(1+num)*right[0];             A[4][1]=y+(1+num)*right[1];
        A[5][0]=x+right[0];                     A[5][1]=y+right[1];
        A[6][0]=x;                              A[6][1]=y;      //tyto krajni body se nebudou interpolovat
        
        middle = null; left = null; right = null; //dispose
        return A;
    }
    
    
    
    
    public static int[] CatmulRomSpline(double t, int C[][]){ //pole 4x2
    //ze 4 bodu a pozice parametru t<0,1> vrati souradnici jednoho bodu CR spline    
        double v3[] = { t*t*t/2, 
                        t*t/2, 
                        t/2, 
                        1/2 };
        double A[][]= {{-1,  3, -3,  1},
                       { 2, -5,  4, -1},
                       {-1,  0,  1,  0},
                       { 0,  2,  0,  0}};
        double B[] = new double[4];
        int X[] = new int[2];

        B[0] = v3[0]*A[0][0] + v3[1]*A[1][0] + v3[2]*A[2][0] + v3[3]*A[3][0];
        B[1] = v3[0]*A[0][1] + v3[1]*A[1][1] + v3[2]*A[2][1] + v3[3]*A[3][1];
        B[2] = v3[0]*A[0][2] + v3[1]*A[1][2] + v3[2]*A[2][2] + v3[3]*A[3][2];
        B[3] = v3[0]*A[0][3] + v3[1]*A[1][3] + v3[2]*A[2][3] + v3[3]*A[3][3];

        X[0] = (int)(B[0]*C[0][0] + B[1]*C[1][0] + B[2]*C[2][0] + B[3]*C[3][0]);
        X[1] = (int)(B[0]*C[0][1] + B[1]*C[1][1] + B[2]*C[2][1] + B[3]*C[3][1]);

        B = null; v3 = null; A = null; //dispose
        return X;
    }
    
    
    
    
    public static int[] Loop(Graphics g, Edge e, int r, int alpha, int delta){
        int x = e.GetFromNode().GetX();
        int y = e.GetFromNode().GetY();
        int num = e.GetCnt();
        
        double DIF=0.05; //krok pri prochazeni intervalu t<0,1>
        int p[][] = new int[4][2];
        int Y[][] =  LoopControlPoints(x, y, r, alpha, delta, num) ;
        int ret[] = new int[2];
            ret[0] = Y[3][0];
            ret[1] = Y[3][1];
        //pro ulozeni startovacich souradnic - kvuli fci drawLine()
        int old[] = new int[2];
            old[0] = Y[1][0];
            old[1] = Y[1][1];
        //postupne nacitam ctverice kontrolnich bodu, ktere interpoluju pomoci CatmulRom spline    
        for(int i=0; i<Y.length-3; i++){
            p[0][0] = Y[0+i][0];        p[0][1] = Y[0+i][1];
            p[1][0] = Y[1+i][0];        p[1][1] = Y[1+i][1];
            p[2][0] = Y[2+i][0];        p[2][1] = Y[2+i][1];
            p[3][0] = Y[3+i][0];        p[3][1] = Y[3+i][1];            
            for(double t=0; t<=1; t=t+DIF){
                int X[] = CatmulRomSpline(t, p);                
                g.drawLine(old[0], old[1], X[0]+p[1][0], X[1]+p[1][1]); //pricitam 2.bod (protoze interpoluju od 2. ke 3. bodu)
                //g.drawOval(Z[0]+p[1][0], (int)Z[1]+p[1][1], 1, 1);
                old[0]=X[0]+p[1][0];
                old[1]=X[1]+p[1][1];
            };
        }//end for
        
        // compute ARROW
            double a = Math.PI * alpha / 180; //prevod na radiany
            double d = Math.PI * delta / 180;
            double uhel = a + d/2;
       // System.out.println(Math.toDegrees(uhel));
            int[] Arr = new int[6];
            Arr[0] = Y[5][0]; //predposledni kontrolni bod smycky, lezi v bode kde bude sipka
            Arr[1] = Y[5][1];
            Arr[2] = (int)(Y[5][0] + 10 * Math.cos(uhel - Math.PI/18)); //10 .. delka sipky
            Arr[3] = (int)(Y[5][1] + 10 * Math.sin(uhel - Math.PI/18)); //PI/36 .. rozevreni sipky
            Arr[4] = (int)(Y[5][0] + 10 * Math.cos(uhel + Math.PI/18));
            Arr[5] = (int)(Y[5][1] + 10 * Math.sin(uhel + Math.PI/18));        
            e.SetArrow(Arr);
            
        p = null; Y = null; //dispose
        
        return ret;        
    }  
    
    
    
    
     public static void Spline(Graphics g, int X[][]){
        double DIF=0.1; //krok pri prochazeni intervalu t<0,1>
        int p[][] = new int[4][2];
        int old[] = new int[2];
            old[0] = X[0][0];
            old[1] = X[0][1];
        //int X[][] = new int[Y.length+2][2];
        //X[0][0]=Y[0][0];
        //X[0][1]=Y[0][1];
        //for(int i=0; i<Y.length; i++){
        //    X[i+1][0]=Y[i][0];
        //    X[i+1][1]=Y[i][1];
        //}
        //System.out.println(Y.length);
        //X[Y.length+1][0]=Y[Y.length-1][0];
        //X[Y.length+1][1]=Y[Y.length-1][1];
        
        for(int i=0; i<X.length-3; i++){
            p[0][0] = X[0+i][0];        p[0][1] = X[0+i][1];
            p[1][0] = X[1+i][0];        p[1][1] = X[1+i][1];
            p[2][0] = X[2+i][0];        p[2][1] = X[2+i][1];
            p[3][0] = X[3+i][0];        p[3][1] = X[3+i][1];
            
             
            for(double t=0; t<=1; t=t+DIF){
                int Z[] = CatmulRomSpline(t, p);
                
                g.drawLine(old[0], old[1], Z[0]+p[1][0], Z[1]+p[1][1]);
                //g.drawOval(Z[0]+p[1][0], (int)Z[1]+p[1][1], 1, 1);
                old[0]=Z[0]+p[1][0];
                old[1]=Z[1]+p[1][1];
            };
        }//end for
        p = null; //dispose
    } 
    
    
    
    
    public static int[] Intersection(int Ax, int Ay, int Bx, int By, int Cx, int Cy) {
    //vraci prusecik primky dane body A,B s primkou k ni kolmou prochazejici bodem C    
        int P[] = new int[2];

        double s= ((double)((By-Ay)*(Cx-Ax-Cy+Ay)) ) / ((double)((Ay-By)*(Ay-By) + (Bx-Ax)*(By-Ay)) );
        
        double t =((double)( (Ay-Cy)*(Ay-By) + (Ax-Cx)*(Ax-Bx) )) / ((double)( (Bx-Ax)*(Bx-Ax) + (Ay-By)*(Ay-By) ));
        
        P[0] = (int)(Ax + t*(Bx-Ax));
        P[1] = (int)(Ay + t*(By-Ay));
        
        return P;
    }
   
    
    
    
    public static int[] NewCtrlPoint(int d, int Ax, int Ay, int Bx, int By, int Cx, int Cy, int Px, int Py, int Cnt, Vars VAR){                
    //pokud vzdalenost pruseciku P a bodu C je mensi nez 'd' vrati novy kontrolni bod
    //v dostatecne vzdalenosti od bodu C ; jinak vraci null
        if ( Math.sqrt((double)((Cx-Px)*(Cx-Px) + (Cy-Py)*(Cy-Py))) < d ) 
        {
            /*
            //TREBA OVLIVNIT I COUNTEREM HRANY
           // if(e.GetCnt()>1){
                    int D[] = new int[2];
                    double t = (e.GetCnt()-1)*VAR.GetEdgeDistance()/Gfx.Distance(Ax, Ay, Bx, By);
                    //x=Px+t*(By-Ay)   y=Py+t*(Ax-Bx)
                    D[0]=(int)(((Ax+Bx)/2) + t*(By-Ay));
                    D[1]=(int)(((Ay+By)/2) + t*(Ax-Bx));
                    e.GetCtrl().addElement(D);
                    //System.out.println("empty: cnt "+TempB.GetCnt()+" "+D[0]+" "+D[1]);
             //   }
*/
            /*
            double t = Math.sqrt((double) ((double)d*d / 
                                 (double)((By-Ay)*(By-Ay) + (Ax-Bx)*(Ax-Bx))));
            int N[] = new int[2];
            N[0] = (int)(Cx + t*(By-Ay));
            N[1] = (int)(Cy + t*(Ax-Bx));
        //    System.out.println("NewCtrlPoint return N");
            return N;
           */
            
            //bod C je prilis blizko, hledam umisteni noveho bodu ve vzdalenosti 'd + odchylka dle cisla hrany' od AB
            //bod C lezi primo na primce, nutno pouzit vektor kolmy k AB
            if( Math.abs(Px-Cx)<=1 && Math.abs(Py-Cy)<=1){
                double t = (d + ((Cnt-1) * VAR.GetEdgeDistance())) / Math.sqrt((Ay-By)*(Ay-By) + (Bx-Ax)*(Bx-Ax));
                int N[] = new int[2];
                N[0] = (int)(Cx + t*(By-Ay)); 
                N[1] = (int)(Cy + t*(Ax-Bx));                             
                return N;
            }
            //bod C lezi mimo primku, pouziji vektor z primky CP
            else{
                double t = (d + ((Cnt-1) * VAR.GetEdgeDistance())) / Math.sqrt((Cx-Px)*(Cx-Px) + (Cy-Py)*(Cy-Py));
                int N[] = new int[2];
               // N[0] = (int)(Cx + t*(By-Ay)); 
               // N[1] = (int)(Cy + t*(Ax-Bx));   
                N[0] = (int)(Cx + t*(Px-Cx)); 
                N[1] = (int)(Cy + t*(Py-Cy));   
                return N;
            }
        }
        else{
            int N[] = new int[2];
            N[0] = -1;
            N[1] = -1;
          //  System.out.println("NewCtrlPoint return [-1, -1]");
            return N;
        }
    }
    
    
    
    
    public static double Distance(int Ax, int Ay, int Bx, int By){
    //vraci vzdalenost dvou bodu
        return Math.sqrt((double) ((Ax-Bx)*(Ax-Bx) + (Ay-By)*(Ay-By)));
    }
    
    
    
    
    public static int Nearest(Vector v, int Ax, int Ay){
    //vraci index ve vektoru pro nejblizsi uzel k souradnicim Ax,Ay; pokud
    //zadny takovy neexistuje, vraci -1
        double minimum = Double.MAX_VALUE;
        int index=-1;
        int B[] = new int[2];
        double dist;
        
        for(int i=0; i<v.size(); i++){
            B=(int[])v.elementAt(i);
            if( (dist = Distance(B[0], B[1], Ax, Ay)) < minimum){
                minimum = dist;
                index = i;
            }
        }
        B = null; //dispose
        return index;
    }
    
    
    
    
}